Lib-Tile-TransparentTextures-Images
===



Intention
---

The library `Lib-Tile-TransparentTextures-Images` contains all 396 images from 
the tileset `Transparent Textures`.
* All images from this library are wrapped in [Tile]s in the class [TransparentTexturesTileSet] 
  which is is located in the library [Lib-Tile-TransparentTextures].
* The images can be loaded over the class [TileProvider] from the library [Lib-Tile-Core] 
  as an [Background] or [Image].
* With the separation from the implementation ([Tile]s) in the library [Lib-Tile-TransparentTextures] 
  and the images in [Lib-Tile-TransparentTextures-Images] the developer can create 
  `reduced` and / or `mixed` [TileSet]s. See the examples in the library [Lib-Tile-Customized-Examples]
  for more information.

> __Hint__  
> This libray is a part from the project [Lib-Tile]. Plz see for additional 
> informations like [Download], [Requirements] or [Installation] there. Thanks :smile:



Content
---

* [Examples](#Examples)
* [Cheat-Sheet TransparentTextures](#ChShTrTe)
* [License](#License)
* [Autor](#Autor)
* [Contact](#Contact)



Examples<a name="Examples" />
---

Examples how to load the `images` and how to use the `predefined`, `reduced`, 
`mixed` and / or `own` [TileSet]s can be found in the `demo` application [Lib-Tile-Demo].

_Image:_ Demo application  
![demo_v0.3.0.png][demo_v0.3.0]



API<a name="API" />
---

### Cheat-Sheet TransparentTextures<a name="ChShTrTe" />

In the [Cheat-Sheet from TransparentTextures] all `396` [Tile]s from the webpage 
https://www.transparenttextures.com/ are listed in the class [TransparentTexturesTileSet].




License<a name="License" />
---

The project `Lib-Tile` and all sub-projects are licensed under [General Public License 3.0].



Autor<a name="Autor" />
---

The project `Lib-Tile` and all sub-projects are maintained by me, Peter Rogge. 
See [Contact](#Contact).



Contact<a name="Contact" />
---

You can reach me under <peter.rogge@yahoo.de>.



[//]: # (Images)
[demo_v0.3.0]:https://user-images.githubusercontent.com/8161815/29042851-02bf3cd4-7bb9-11e7-818d-28c7260c0c25.png



[//]: # (Links)
[Background]:https://docs.oracle.com/javase/8/javafx/api/javafx/scene/layout/Background.html
[Cheat-Sheet from TransparentTextures]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-TransparentTextures/Cheat-Sheet-TransparentTextures.md
[Download]:https://github.com/Naoghuman/lib-tile/blob/master/README.md#Download
[General Public License 3.0]:http://www.gnu.org/licenses/gpl-3.0.en.html
[Image]:https://docs.oracle.com/javase/8/javafx/api/javafx/scene/image/Image.html
[Installation]:https://github.com/Naoghuman/lib-tile/blob/master/README.md#Installation
[Lib-Tile]:https://github.com/Naoghuman/lib-tile
[Lib-Tile-Core]:https://github.com/Naoghuman/lib-tile/tree/master/Lib-Tile-Core
[Lib-Tile-Customized-Examples]:https://github.com/Naoghuman/lib-tile/tree/master/Lib-Tile-Customized-Examples
[Lib-Tile-TransparentTextures]:https://github.com/Naoghuman/lib-tile/tree/master/Lib-Tile-TransparentTextures
[Lib-Tile-TransparentTextures-Images]:https://github.com/Naoghuman/lib-tile/tree/master/Lib-Tile-TransparentTextures-Images
[Requirements]:https://github.com/Naoghuman/lib-tile/blob/master/README.md#Requirements
[Tile]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-Core/src/main/java/com/github/naoghuman/lib/tile/core/Tile.java
[TileProvider]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-Core/src/main/java/com/github/naoghuman/lib/tile/core/TileProvider.java
[TileSet]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-Core/src/main/java/com/github/naoghuman/lib/tile/core/TileSet.java
[TransparentTexturesTileSet]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-TransparentTextures/src/main/java/com/github/naoghuman/lib/tile/transparenttextures/TransparentTexturesTileSet.java
[TransparentTexturesTileLoader]:https://github.com/Naoghuman/lib-tile/blob/master/Lib-Tile-TransparentTextures-Images/src/main/java/com/github/naoghuman/lib/tile/transparenttextures/images/TransparentTexturesTileLoader.java
